function SliceCommander:NewFrame(color)
	local f = CreateFrame("StatusBar", nil, UIParent)

	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetValue(0)
	f:SetDefaultBackdrop()
	f:SetBackdropColor(unpack({.1,.1,.1,.7}))
	f:SetFrameStrata("MEDIUM")

	-- text on the right --
	f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	f.text:SetFontObject(SC.BarFont1)
	f.text:SCWidth(120)
	f.text:SCPoint("TOPRIGHT", f, "TOPRIGHT", -5, 0)
	f.text:SetJustifyH("RIGHT")

	f.icon = f:CreateTexture(nil, "OVERLAY")
	f.icon:SCPoint("RIGHT", f, "LEFT", -2, 0)
	f.icon:SetTexCoord(.08, .92, .08, .92)

	-- text on the center --
	f.text2 = f:CreateFontString(nil, nil, nil)
	f.text2:SCPoint("CENTER", f, "CENTER", -8, 0)
	f.text2:SetFontObject(SC.BarFont1)
	f.text2:SCWidth(200)
	f.text2:SetJustifyH("CENTER")

	f:SetStatusBarColor(unpack(color))
	f.border = SliceCommander:tukSkin(f, false)
	f.iconBorder = SliceCommander:tukSkin(f, f.icon)

	return f

end

function SliceCommander:CPFrame()
	local f = CreateFrame("StatusBar", nil, UIParent)

	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:SCPoint("TOPLEFT", f, "TOPLEFT", 0, 0)
	f.bg:SCPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 0)
	f:SetFrameStrata("MEDIUM")

	f.combos = {}

	for i = 1, 10 do--Maximum CP is 10 with anticipation
		local combo = CreateFrame("Frame", nil, f)
		combo.bg = combo:CreateTexture(nil, "BACKGROUND")
		combo.bg:SetAllPoints(combo)
		combo.bg:SetTexture("Interface\\AddOns\\SliceCommander\\Images\\solid.tga")
		combo.border = SliceCommander:tukSkin(combo, false)
		combo:Hide()
		f.combos[i] = combo
	end

	f.overlay = CreateFrame("Frame", nil, f)
	f.overlay:SetAllPoints(f)
	
	f.comboText = f.overlay:CreateFontString(nil, 'OVERLAY')
	f.comboText:SetFont(SliceCommander:GetFont(), 8, "THINOUTLINE")
	f.comboText:SetShadowColor(0, 0, 0, 0.4)
	f.comboText:SetTextColor(1, 1, 1)
	f.comboText:SetShadowOffset(1, -1)	
	f.comboText:SetJustifyH("CENTER")
	f.comboText:SCWidth(120)
	f.comboText:SetAllPoints(f.overlay)

	f:Hide()
	return f

end

function SliceCommander:ThinBar(point, relativePoint, x, y)
	local f = CreateFrame("StatusBar", nil, UIParent)
	f:SCHeight(2)
	f:SetFrameLevel(2)
	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetStatusBarColor(64/255, 167/255, 64/255)
	f:SetMinMaxValues(0, 3600*1000)
	f:SetFrameStrata("MEDIUM")
	f:Hide()
	f:SetDefaultBackdrop()
	local r,v,b = unpack(SC.V.bColor)
	f:SetBackdropBorderColor(unpack(SC.V.wColor))
	f:SetBackdropColor(r,v,b,0)
	f:SetPoint(point, VTimerEnergy, relativePoint, x, y)
	return f
end

function SliceCommander:CreateMoveFrame()
	CreateFrame('Frame', 'SliceCommanderFrame', UIParent)
	SliceCommanderFrame:SetToplevel(true)
	SliceCommanderFrame:EnableMouse(false)
	SliceCommanderFrame:SetMovable(true)
	SliceCommanderFrame:SCSize(216, 36)
	SliceCommanderFrame:SetPoint(
		SC.OTHER['SliceCommanderFrame']['position'].point,
		SC.OTHER['SliceCommanderFrame']['position'].relativeTo,
		SC.OTHER['SliceCommanderFrame']['position'].relativePoint,
		SC.OTHER['SliceCommanderFrame']['position'].xOfs,
		SC.OTHER['SliceCommanderFrame']['position'].yOfs
	)
	SliceCommanderFrame:SetDefaultBackdrop()
	SliceCommanderFrame:SetBackdropColor(0.7,0.2,0.2,1)
	SliceCommanderFrame:SetScript("OnMouseDown",function () SliceCommander:MoveStart(SliceCommanderFrame) end)
	SliceCommanderFrame:SetScript("OnMouseUp",function () SliceCommander:MoveStop(SliceCommanderFrame) end)
	SliceCommanderFrame:SetScript("OnUpdate",function () SliceCommander:OnUpdate() end)
end

function SliceCommander:CreateEnergyFrame()
	CreateFrame('StatusBar', 'VTimerEnergy', UIParent)
	VTimerEnergy:SCSize(200, 20)
	VTimerEnergy:SetMinMaxValues(0,100)
	VTimerEnergy:SCPoint('CENTER', SliceCommanderFrame, 'CENTER', 0, 0)
	VTimerEnergy:SetFrameLevel(1)
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"))
	VTimerEnergy:SetDefaultBackdrop()
	VTimerEnergy:SetBackdropBorderColor(unpack(SC.V.wColor))
	VTimerEnergy:SetBackdropColor(unpack({.1,.1,.1,.7}))
	VTimerEnergy:SetStatusBarTexture(SliceCommander:BarTexture())
	VTimerEnergy:SetFrameStrata("MEDIUM")
	VTimerEnergy:SetFrameLevel(1)
	VTimerEnergy:SetStatusBarColor(unpack(SC.SET.energyColor))
	VTimerEnergy.border = SliceCommander:tukSkin(VTimerEnergy, false)
	if SC.SET.HideEnergy then
		VTimerEnergy:Hide()
	else
		VTimerEnergy:Show()
	end

	VTimerEnergy:CreateFontString('VTimerEnergyTxt', 'OVERLAY', GameFontWhite)
	VTimerEnergyTxt:SetJustifyH("RIGHT")
	VTimerEnergyTxt:SCSize(49, 20)
	VTimerEnergyTxt:SCPoint('RIGHT', VTimerEnergy, 'RIGHT', -5, 0)
	VTimerEnergyTxt:SetFontObject(SliceCommander:NewFont("VTimerFont", 17, 0.7, 1, 1, 1))
end

function SliceCommander:CreateComboText()
	VTimerEnergy:CreateFontString('SliceCommander_Combo', 'OVERLAY')
	SliceCommander_Combo:SetFont(SliceCommander:GetFont(), 17, "THINOUTLINE")
	SliceCommander_Combo:SetShadowColor(0, 0, 0, 0.4)
	SliceCommander_Combo:SetTextColor(1, 1, 1)
	SliceCommander_Combo:SetShadowOffset(1, -1)	
	SliceCommander_Combo:SetJustifyH("LEFT")
	SliceCommander_Combo:SCSize(40, 20)
	SliceCommander_Combo:SCPoint('TOPLEFT', VTimerEnergy, 'TOPLEFT', 5, 0)
end

function SliceCommander:CreateSpark()
	for i = 1, 3 do
		SC.Spark[i] = VTimerEnergy:CreateTexture(nil, 'OVERLAY', GameFontWhite)
		SC.Spark[i]:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		SC.Spark[i]:SetBlendMode('ADD')
		SC.Spark[i]:SCSize(5,20)
	end
end

function SliceCommander:NewTickArray(BAR)
	local tickObj = BAR['obj']:CreateTexture(nil, 'OVERLAY', GameFontWhite)
	tickObj:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\solid.tga')
	tickObj:SCWidth(2)
	tickObj:SCHeight(SC.SET.TimerHeight)
	tickObj:SetVertexColor(226/255, 226/255, 226/255, 0.75)
	table.insert(_G['SCtick'], tickObj)
	return tickObj
end

function SliceCommander:NewMoveFrameIcon(name)
	local MoveFrame = CreateFrame('Button', name, UIParent)
	MoveFrame:SetToplevel(true)
	MoveFrame:EnableMouse(false)
	MoveFrame:SetMovable(true)
	MoveFrame:SCSize(28, 28)
	MoveFrame:SetPoint(
		SC.OTHER[name]['position'].point,
		SC.OTHER[name]['position'].relativeTo,
		SC.OTHER[name]['position'].relativePoint,
		SC.OTHER[name]['position'].xOfs,
		SC.OTHER[name]['position'].yOfs
	)
	MoveFrame:SetDefaultBackdrop()
	MoveFrame:SetBackdropColor(0.7,0.2,0.2,1)
	MoveFrame:SetScript("OnMouseDown",function () SliceCommander:MoveStart(MoveFrame) end)
	MoveFrame:SetScript("OnMouseUp",function () SliceCommander:MoveStop(MoveFrame) end)

	return MoveFrame
end

function SliceCommander:NewIcon(icon, name)
	local MoveFrame = SliceCommander:NewMoveFrameIcon(name)

	local f = CreateFrame("Frame", name..'button', UIParent)
	f:SCPoint('CENTER', name, 'CENTER', 0, 0)
	f:SetFrameStrata("MEDIUM")
	f:SetFrameLevel(1)
	f.moveframe = MoveFrame

	local fIcon = f:CreateTexture(nil)
	fIcon:SCPoint("CENTER", f, "CENTER", 0, 0)
	fIcon:SetAlpha(1)
	fIcon:SetTexCoord(.08, .92, .08, .92)
	fIcon:SetTexture(icon)
	f.icon = fIcon
	f.border = SliceCommander:tukSkin(f, fIcon)

	f.overlay = CreateFrame('Frame', nil, f)
	f.overlay:SetFrameStrata("HIGH")
	f.overlay:SetFrameLevel(2)
	f.overlay:SCPoint('CENTER', f:GetName(), 'CENTER', 0, 0)
	f.overlay:SetDefaultBackdrop()
	f.overlay:SetBackdropColor(0,0,0,.3)
	f.overlay:Hide()

	f.iconTxt = f.overlay:CreateFontString(nil, 'OVERLAY', GameFontWhite)
	f.iconTxt:SetJustifyH("CENTER")
	f.iconTxt:SetJustifyV("MIDDLE")
	f.iconTxt:SCPoint('CENTER', f, "CENTER", 2, 0)
	f.iconTxt:SetFontObject(SC.FontIcon)
	f.iconTxt:SetShadowColor(0,0,0,1)
	f.iconTxt:SetShadowOffset(2*SC.V.pxW, -2*SC.V.pxH)

	return f
end

function SliceCommander:NewFont(name, FontSize, aShadow, rColor, gColor, bColor)
	local f = CreateFont(name)
	f:SetFont(SliceCommander:GetFont(), FontSize)
	f:SetShadowColor(0, 0, 0, aShadow)
	f:SetTextColor(rColor, gColor, bColor, 1)
	f:SetShadowOffset(0.8, -0.8)

	return f
end

function SliceCommander:CreateTextureSkin(frame, color, level, texture)
	local t = CreateFrame('Frame', nil, frame)
	t:SetDefaultBackdrop()
	t:SetFrameLevel(level)
	t:SetFrameStrata("LOW")
	t:SetBackdropColor(unpack(color))
	if texture then
		t:SCPoint("CENTER", texture, "CENTER", 0, 0)
	else
		t:SCPoint("CENTER", frame, "CENTER", 0, 0)
	end
	t:Show()

	return t
end

function SliceCommander:tukSkin(frame, texture)
	return {
		[1] = SliceCommander:CreateTextureSkin(frame, SC.V.bColor, 1, texture),
		[2] = SliceCommander:CreateTextureSkin(frame, SC.V.wColor, 2, texture),
		[3] = SliceCommander:CreateTextureSkin(frame, SC.V.bColor, 3, texture)
	}
end